﻿"use strict";
var currentState; // this will start in state 1 (in the ready function, below)

// if the king's firstborn is rescued 
//  then player gets to pick whether they've rescued a prince or princess :)
var firstBornGender; 

function setup_DiedByDragon() {
	$("#thePicture").attr("src", "image100.png");

	$("#choice1").show().val("Restart the game");
	$("#choice2").hide();
	$("#choice3").hide();
	return 100;
}

function setup_gameWon() { // just because we've won doesn't mean the story needs to end :)
	$("#thePicture").attr("src", "image09.png");
	
	var congrats = "Congratulations - you've rescued the ";
	if( firstBornGender == "male") {
		congrats += "prince!";
	}
	else if ( firstBornGender == "female") {
		congrats += "princess!";
	}
				
	$("#msg").show().html( congrats );
	$("#choice1").show().val("THIS BUTTON DOES NOTHING");
	$("#choice2").hide();
	$("#choice3").hide(); 
	return 9; // state isn't really define (no 'handler' code for it)
}

function setup_GenderChoice() {
	$("#thePicture").attr("src", "image08.png");
	
	$("#choice1").show().val("The firstborn was a prince");
	$("#choice2").show().val("The firstborn was a princess");
	$("#choice3").hide(); 
	return 8;
}
function handle_GenderChoice(whichBtn) {
	// They've talked the dragon into leaving
	if( whichBtn == 1) {
		firstBornGender = "male"; // if only JavaScript had enums.  Or even constants.  *sigh* :(
	}
	else if( whichBtn == 2) {
		firstBornGender = "female";
	}
	
	currentState = setup_gameWon(); // just because we've won doesn't mean the story needs to end :)
}
function setup_GotEquipment() {
	$("#thePicture").attr("src", "image07.png");
	
	$("#choice1").show().val("Fight the dragon");
	$("#choice2").show().val("Bluff the dragon");
	$("#choice3").hide(); 
	return 7;
}
function handle_GotEquipment(whichBtn) {
	// They've gotten equipment - do they fight or talk?
	if( whichBtn == 1) { // fight
		currentState = setup_DiedByDragon();
	}
	else if( whichBtn == 2) { // talk
		currentState = setup_GenderChoice();
	}
}
function setup_Profiteering() {
	$("#thePicture").attr("src", "image06.png");
	
	$("#choice1").show().val("THIS BUTTON DOES NOTHING");
	$("#choice2").hide();
	$("#choice3").hide(); // setting the show/hide for all buttons
	return 6;
}
function setup_FindSomeEquipment() {
	$("#thePicture").attr("src", "image05.png");
	
	$("#choice1").show().val("Sell the equipment in another town!");
	$("#choice2").show().val("Seek out the dragon");
	$("#choice3").hide(); 
	return 5;
}
function handle_FindSomeEquipment(whichBtn) {
	// They're looking for equipment
	if( whichBtn == 1) { // They're off to make money in the free market
		currentState = setup_Profiteering(); // go arbitrage go! :)
	}
	else if( whichBtn == 2) {
		currentState = setup_GotEquipment();
	}
}
function setup_DragonFlyingPlayerBackToTown() {
	$("#thePicture").attr("src", "image04.png");

	$("#choice1").show().val("Try, try again");
	$("#choice2").hide();
	$("#choice3").hide(); // setting the show/hide for all buttons
	return 4;
}

function setup_FindTheDragon_Unarmed() {
	$("#thePicture").attr("src", "image03.png");

	$("#choice1").show().val("Try to talk your way out of this one");
	$("#choice2").show().val("Fight the dragon!");
	$("#choice3").hide(); 
	return 3;
}
function handle_FindTheDragon_Unarmed(whichBtn) {
	// They're confronting the dragon WIHTOUT any equpiment
	if( whichBtn == 1) { // Reset things to being "in town"
		currentState = setup_DragonFlyingPlayerBackToTown();
	}
	else if( whichBtn == 2) {
		currentState = setup_DiedByDragon();
	}
}

function setup_GameStarted() {
	$("#thePicture").attr("src", "image02.png");
	
	$("#choice1").show().val("Go find the dragon, right away!");
	$("#choice2").show().val("Get some equipment first!");
	$("#choice3").hide(); // setting the show/hide for all buttons
		// each time is easier than keeping track of which
		// ones where shown/hidden on the previous screen
	return 2;
}

function handle_GameStarted(whichBtn) {
	if( whichBtn == 1) { // If they chose "go find the dragon":
		currentState = setup_FindTheDragon_Unarmed();
	}
	else if( whichBtn == 2) { // If they chose "go find some equipment":
		currentState = setup_FindSomeEquipment();
	}
}

function setup_GameStart()
{
	$("#thePicture").attr("src", "image01.png");

	$("#choice1").val("Click here to start!");
	$("#choice2").hide();
	$("#choice3").hide();
	
	return 1; // current state will now be 1
}

function onClick()
{
	// The following will tell you the id of the button that was pressed
	// alert(" You clicked on: " + $(this).attr("id") );
	
	// whichButton will contain a number representing which button was clicked
	// yes, we could have used the string directly, 
	// but this is less error prone (typos are easier to see for a single-digit
	//		number)
	var whichButton  =0;
	
	if( $(this).attr("id") == "choice1") {
		whichButton = 1;
	}
	else if( $(this).attr("id") == "choice2") {
		whichButton = 2;
	}
	else if( $(this).attr("id") == "choice3")  {
		whichButton = 3;
	}
	
	if( currentState == 1) {
		// If the current state is 1, it's because they've just started the game
		
		// There's only 1 button to push: here's what to do when that happens
		currentState = setup_GameStarted();
	}
	else if( currentState == 2) {
		// They're "in town"
		handle_GameStarted();
	}
	else if( currentState == 3) {
		handle_FindTheDragon_Unarmed();
	}
	else if( currentState == 4) {
		// Player talked to dragon - there's only 1 button, so always
		// reset things to being "in town"
		currentState = setup_GameStarted();
	}
	else if( currentState == 5) {
		handle_FindSomeEquipment();
	}
	else if( currentState == 7) {
		handle_GotEquipment();
	}
	else if( currentState == 8) {
		handle_GenderChoice();
	}
	else if( currentState == 100) {
		// The player is dead (because of the dragon)
		
		// Their only option is to click "restart":
		currentState = setup_GameStart();		
	}
}

$(document).ready( function() {

	$("#msg").hide(); // BUGBUG: we only reset this here!

	$("#choice1").click( onClick );
	$("#choice2").click( onClick );
	$("#choice3").click( onClick );	

	// Set up the game to start:
	currentState = setup_GameStart();
});